SystemOrganization addCategory: #'EjerciciosPoo-Distance'!

Object subclass: #Measure
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Measure class methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/8/2013 19:35'!
newMeasure: aValue withUnit: aUnit 

	|aMeasure|

	 aMeasure := self new.
	^aMeasure initializeMeasure: aValue withUnit: aUnit. ! !

!Measure methodsFor: 'arithmetic' stamp: 'MartinCarreiro 5/13/2013 20:13'!
* anEscalar
	
	^ Measure newMeasure: ((self amount) * anEscalar ) withUnit: self unit.! !

!Measure methodsFor: 'arithmetic' stamp: 'MartinCarreiro 5/13/2013 20:13'!
+ anotherMeasure
	
	^ Measure newMeasure: (self amountNormalized + anotherMeasure amountNormalized ) withUnit: Unit meter.! !

!Measure methodsFor: 'arithmetic' stamp: 'MartinCarreiro 5/13/2013 20:14'!
- anotherMeasure
	
	^ self + anotherMeasure negated.! !

!Measure methodsFor: 'arithmetic' stamp: 'MartinCarreiro 5/13/2013 20:14'!
/ anEscalar
	
	^self * (1/anEscalar).! !

!Measure methodsFor: 'arithmetic' stamp: 'PabloRago 5/15/2013 19:47'!
// anotherMeasure
	
	^self amountNormalized // anotherMeasure amountNormalized .! !

!Measure methodsFor: 'comparing' stamp: 'PabloRago 5/15/2013 20:29'!
< anotherMeasure
	
	^self compareUsing: #< with: anotherMeasure.! !

!Measure methodsFor: 'comparing' stamp: 'PabloRago 5/15/2013 20:29'!
<= anotherMeasure
	
	^self compareUsing: #<= with: anotherMeasure. ! !

!Measure methodsFor: 'comparing' stamp: 'PabloRago 5/15/2013 21:49'!
= anotherMeasure

	^ (anotherMeasure isKindOf: Measure)and: [(self compareUsing: #= with: anotherMeasure) ]. ! !

!Measure methodsFor: 'comparing' stamp: 'PabloRago 5/15/2013 20:29'!
> anotherMeasure

	^self compareUsing: #> with: anotherMeasure. ! !

!Measure methodsFor: 'comparing' stamp: 'PabloRago 5/15/2013 20:29'!
>= anotherMeasure

	^self compareUsing: #>= with: anotherMeasure. ! !

!Measure methodsFor: 'arithmetic' stamp: 'PabloRago 5/15/2013 19:47'!
\\ anotherMeasure
	
	^self amountNormalized \\ anotherMeasure amountNormalized .! !

!Measure methodsFor: 'getters' stamp: 'MartinCarreiro 5/16/2013 12:14'!
amount 

	^amount.! !

!Measure methodsFor: 'getters' stamp: 'PabloRago 5/12/2013 13:37'!
amountNormalized
	^(amount / (10**unit factor)).! !

!Measure methodsFor: 'comparing' stamp: 'PabloRago 5/15/2013 20:30'!
between: aMeasure and: anotherMeasure 

	^(self > aMeasure) and: [self < anotherMeasure]. ! !

!Measure methodsFor: 'comparing' stamp: 'PabloRago 5/15/2013 21:49'!
compareUsing: aMessage with: other
	
	^  (self amountNormalized) perform: aMessage with: (other amountNormalized).! !

!Measure methodsFor: 'arithmetic' stamp: 'PabloRago 5/12/2013 13:36'!
convertTo: aUnit
	
	amount := amount * (10 ** (aUnit factor - unit factor)).
	unit := aUnit.
	^self.! !

!Measure methodsFor: 'initialize-release' stamp: 'MartinCarreiro 5/13/2013 20:14'!
copy
	
	^ Measure newMeasure: self amount withUnit: (self unit)
! !

!Measure methodsFor: 'getters' stamp: 'MartinCarreiro 5/13/2013 19:37'!
hash

	"Multiplicamos por 31 porque es primo y porque somos 3 en el grupo pero parecemos 1 :) "
	^self amountNormalized *31.! !

!Measure methodsFor: 'initialize-release' stamp: 'PabloRago 5/8/2013 20:17'!
initializeMeasure: anAmount withUnit: aUnit
	amount := anAmount.
	unit := aUnit.! !

!Measure methodsFor: 'arithmetic' stamp: 'MartinCarreiro 5/13/2013 20:14'!
max: anotherMeasure

	^ Measure newMeasure: (self amountNormalized  max: anotherMeasure amountNormalized)  withUnit: Unit meter.! !

!Measure methodsFor: 'arithmetic' stamp: 'PabloRago 5/15/2013 21:33'!
min:  anotherMeasure

	^ Measure newMeasure: (self amountNormalized  min: anotherMeasure amountNormalized)  withUnit: Unit meter.! !

!Measure methodsFor: 'arithmetic' stamp: 'MartinCarreiro 5/13/2013 20:15'!
negated
	
	^ Measure newMeasure: (self amount) * (-1) withUnit: self unit.! !

!Measure methodsFor: 'arithmetic' stamp: 'PabloRago 5/15/2013 21:47'!
negative

	^ self amount negative.! !

!Measure methodsFor: 'getters' stamp: 'MartinCarreiro 5/13/2013 21:08'!
oneMeasureWithMyUnit

	^ Measure newMeasure: 1 withUnit: self unit.! !

!Measure methodsFor: 'getters' stamp: 'PabloRago 5/8/2013 20:33'!
printString
	^ amount asString , ' ' , unit printString asPluralBasedOn: amount .! !

!Measure methodsFor: 'intervals' stamp: 'PabloRago 5/15/2013 21:51'!
to: aMeasure

	^Interval from: self  to: aMeasure by: self oneMeasureWithMyUnit! !

!Measure methodsFor: 'intervals' stamp: 'PabloRago 5/15/2013 19:43'!
to: aMeasure by: aMeasureStep

	^Interval from: self  to: aMeasure by: aMeasureStep ! !

!Measure methodsFor: 'getters' stamp: 'PabloRago 5/8/2013 19:49'!
unit
	^unit.! !

Object subclass: #Unit
	instanceVariableNames: 'name factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!Unit class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 5/13/2013 20:11'!
centimeter

	^ Unit newUnit: 'centimeter' withFactor: 2
! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 5/13/2013 20:12'!
decameter

	^ Unit newUnit: 'decameter' withFactor: -1
! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 5/13/2013 20:12'!
decimeter

	^ Unit newUnit: 'decimeter' withFactor: 1
! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 5/13/2013 20:12'!
hectometer

	^ Unit newUnit: 'hectometer' withFactor: -2
! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 5/13/2013 20:12'!
kilometer

	^ Unit newUnit: 'kilometer' withFactor: -3
! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 5/13/2013 20:11'!
meter

	^ Unit newUnit: 'meter' withFactor: 0
! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 5/13/2013 20:12'!
milimeter

	^ Unit newUnit: 'milimeter' withFactor: 3
! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'MartinCarreiro 5/13/2013 20:13'!
millimeter

	^ Unit newUnit: 'millimeter' withFactor: 3
! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'PabloRago 5/12/2013 12:46'!
newUnit: aName withFactor: aFactor 

	|aUnit|

	 aUnit := self new.
	^aUnit initializeUnit: aName withFactor: aFactor. ! !

!Unit methodsFor: 'comparing' stamp: 'PabloRago 5/12/2013 13:18'!
= anotherUnit
	^ name = anotherUnit name.! !

!Unit methodsFor: 'initialize-release' stamp: 'MartinCarreiro 5/13/2013 19:17'!
copy

	^ Unit newUnit: self name withFactor: self factor .! !

!Unit methodsFor: 'getters' stamp: 'PabloRago 5/12/2013 12:57'!
factor
	^ factor.! !

!Unit methodsFor: 'initialize-release' stamp: 'PabloRago 5/12/2013 12:48'!
initializeUnit: aName withFactor: aFactor

	name := aName.
	factor := aFactor.! !

!Unit methodsFor: 'getters' stamp: 'PabloRago 5/12/2013 12:58'!
name 
	^name.! !

!Unit methodsFor: 'getters' stamp: 'PabloRago 5/12/2013 12:50'!
printString
	^ name.! !

TestCase subclass: #DistanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Distance'!

!DistanceTest methodsFor: 'distance units' stamp: 'MartinCarreiro 5/13/2013 20:15'!
centimeter
	
	^ Unit centimeter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'MartinCarreiro 5/13/2013 20:15'!
decameter
	
	^ Unit decameter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'MartinCarreiro 5/13/2013 20:15'!
decimeter
	
	^ Unit decimeter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceExamples 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"
	
	| distancesCategory distancesMessageNames |
	
	distancesCategory := self class organization categoryOfElement: thisContext method selector.
	distancesMessageNames := (self class organization listAtCategoryNamed:  distancesCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ distancesMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/18/2011 16:07'!
distanceUnits 

	"Quin se anima a explicar cmo funciona este mtodo? 
	Por qu est hecho as? 
	Ver distanceUnits... se puede mejorar algo entre estos dos mtodos?"

	| unitsCategory unitsMessageNames |
	
	unitsCategory := self class organization categoryOfElement: thisContext method selector.
	unitsMessageNames := (self class organization listAtCategoryNamed:  unitsCategory) reject: [ :aMessageName | aMessageName = thisContext method selector ].
	
	 ^ unitsMessageNames collect: [ :aMessageName | self perform: aMessageName ]
	
! !

!DistanceTest methodsFor: 'distance units' stamp: 'MartinCarreiro 5/13/2013 20:15'!
hectometer
	
	^ Unit hectometer.! !

!DistanceTest methodsFor: 'distance units' stamp: 'MartinCarreiro 5/13/2013 20:16'!
kilometer
	
	^ Unit kilometer.! !

!DistanceTest methodsFor: 'distance units' stamp: 'MartinCarreiro 5/13/2013 20:16'!
meter

	^ Unit meter.! !

!DistanceTest methodsFor: 'distance units' stamp: 'MartinCarreiro 5/13/2013 20:16'!
millimeter
	
	^ Unit millimeter .! !

!DistanceTest methodsFor: 'distance measures' stamp: 'PabloRago 5/12/2013 13:06'!
minusOneMeter 
	
	^ Measure newMeasure: -1 withUnit: self meter.! !

!DistanceTest methodsFor: 'distance measures' stamp: 'PabloRago 5/12/2013 13:07'!
oneCentimeter
	
	^ Measure newMeasure: 1 withUnit: self centimeter ! !

!DistanceTest methodsFor: 'distance measures' stamp: 'PabloRago 5/12/2013 13:07'!
oneHundredCentimeters
	
	^ Measure newMeasure: 100 withUnit: self centimeter ! !

!DistanceTest methodsFor: 'distance measures' stamp: 'PabloRago 5/12/2013 13:07'!
oneMeter
	
	^ Measure newMeasure: 1 withUnit: self meter ! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 15:04'!
test01ObjectsRepresentingSameDistanceShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneHundredCentimeters = self oneHundredCentimeters.
	

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test02DiferentDistancesShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self twoMeters = self oneMeter! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/18/2011 16:50'!
test03SameDistanceExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/19/2011 10:28'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).

! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'NPM 5/8/2013 18:54'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'millimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'NPM 5/8/2013 18:54'!
test06DistanceStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:26'!
test07aDistanceAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'PabloRago 5/12/2013 13:17'!
test07bDistanceUnitShouldBeTheExpectedUnit
	
	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test07cDifferentDistanceUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self distanceUnits groupedBy: [ :aDistanceUnit | aDistanceUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!DistanceTest methodsFor: '2 - Converting/accesing/printing' stamp: 'PabloRago 5/8/2013 21:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'MartinCarreiro 5/13/2013 19:07'!
test08aComparingDistancesWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08bDistancesThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.

	
	
! !

!DistanceTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/19/2011 10:27'!
test08cCopiesOfTheSameDistanceShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test09AddingDistancesOfSameUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneMeter) = self twoMeters

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:34'!
test10AddingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheAddingDistances

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.

! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test11AddingDistancesIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter)


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:35'!
test12AddingDistancesIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters))


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test12aAddingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13aNegatingADistanceNegatesItsAmount

	self assert: self oneMeter negated = self minusOneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:36'!
test13bNegatingADistanceIsReflective

	self assert: self oneMeter negated negated=self oneMeter.
	
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:38'!
test14SubtractingDistancesOfSameUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test15SubtractingDistancesOfDifferentUnitShouldReturnADistanceRepresentingTheSubtractedDistances

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated
	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:40'!
test16SubtractingDistancesIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	

	! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:41'!
test16aSubtractingDistancesKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:45'!
test17aDistancesCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'MartinCarreiro 5/13/2013 19:33'!
test17bDistancesCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'MartinCarreiro 5/13/2013 19:33'!
test17cDistancesCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).
! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:47'!
test18MultiplicationKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:48'!
test19aDistancesCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.


! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/21/2011 17:24'!
test19bDistancesCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test19cDistancesCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).




! !

!DistanceTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/18/2011 15:49'!
test20DivisionKeepsDistanceInmutability

	| oneMeter |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	


! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'MartinCarreiro 5/13/2013 19:44'!
test21DistancesProvideATotalOrder

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance < (aDistance + self oneMeter)])

! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'MartinCarreiro 5/13/2013 19:44'!
test22DistancesCanBeComparedWithGreaterThan

	self assert: (self distanceExamples allSatisfy: [ :aDistance | (aDistance + self oneMeter) > aDistance ])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'MartinCarreiro 5/13/2013 19:50'!
test23DistancesCanBeComparedWithLessThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance <= aDistance and: [aDistance <= (aDistance + self oneMeter)]])

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'MartinCarreiro 5/13/2013 19:50'!
test24DistancesCanBeComparedWithGreaterThanOrEqual

	self assert: (self distanceExamples allSatisfy: [ :aDistance | aDistance >= aDistance and: [(aDistance + self oneMeter) >= aDistance]])
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:13'!
test25MaxReturnsTheMaximumBetweenTwoDistances

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test26MinReturnsTheMinimumBetweenTwoDistances

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!DistanceTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/18/2011 16:14'!
test27BetweenAndReturnsTrueIfADistanceIsBetweenOtherTwoDistances

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test28IntervalOfDistancesCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) from=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) to=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) by=self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) from=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) to=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) by=self oneCentimeter.	
	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:16'!
test29DistanceIntervalStepCanBeAnyDistance

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) from=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) to=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) by=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) from=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) to=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) by=self twoMeters negated

	! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:17'!
test30DistanceIntervalSizeReturnsTheNumberOfDistancesOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:19'!
test31DistanceIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!DistanceTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/18/2011 16:27'!
test32DistanceIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aDistance |
		self assert: aDistance amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!DistanceTest methodsFor: 'distance measures' stamp: 'PabloRago 5/12/2013 13:07'!
twoHundredCentimeters
	
	^ Measure newMeasure: 200 withUnit: self centimeter ! !

!DistanceTest methodsFor: 'distance measures' stamp: 'PabloRago 5/12/2013 13:07'!
twoMeters
	
	^ Measure newMeasure: 2 withUnit: self meter ! !

!DistanceTest methodsFor: 'distance measures' stamp: 'PabloRago 5/12/2013 13:07'!
zeroMeters

	^ Measure newMeasure: 0 withUnit: self meter ! !
